//+-----------------------------------------------------------------------+
//|                                                        SuperFXAnt.mq4 |
//|         created by Huhenyo modgepodgeing code from UniversalMACrossEA |
//|         and FXAnt(HG).  Original idea comes from Renato P. dos Santos |
//          Renato's website is www.reniza.com
//+-----------------------------------------------------------------------+
#property copyright "Copyright  2006, Everyone"   

//Input variable that can be edited by the user when testing
//These varieable are those found under the input tab when looking at the EA's properties
extern string  MM_Parameters   = "---------- Money Management ----------";//Just a heading
extern bool MM                 = true; //Use Money Management or not
extern double Lots             = 1;  //Number of lots to use.  If MM is true it will increase lots with increased margin
extern int Risk                = 10; //How much margin to risk 10%.  Remeber that total risk is determined by your s/l
extern string Other_Paramaters = "-------- Execution Management --------";//Just another heading
extern int stoploss            = 17;  //This is your user defined s/l
extern int takeprofit          = 10;  //This is your user defined t/p
extern int BarSpread           = 10; //How much the bar has to spread apart before a trade will execute
extern int MaxTrades           = 1;  //Max number of trades that can be executed at any one given time

//Global variables but not ones that can be manually changed in the EA's properties
int Ticket;
int ID=983783;         

//Allow comments to be displayed 
void deinit() {
   Comment("");
}

//This code keeps the EA from opening more trades than the user desires  
//It is controled by the user defined variable MaxTrades
int orderscnt(){
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && ID==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}

//This is the meat of the EA  
int start()
  {
   double sl,tp; //Variable that will be used to store sl and tp data
   if(MM)Lots = subLotSize(); //If MM is true then execute the MM function to increase lots with increasing margin
   if (Period() < 30) {Comment("change to M30 or higher pls"); return(0); }
   //if (MathMod(Minute(),Period()) >= 0.5*Period()) return(0);  I have no idea what this was originally for

   //If bar/candle has moved more than 10 pips in this time frame and if the open is less than the
   //average of the high and the low and at the current moment the ask is less than the open, go long
   if ((High[0]-Low[0])>BarSpread*Point && Bid<(High[0]+Low[0])/2)
     {
     if(orderscnt()<MaxTrades)//This determines how many trades to make at one time
       {
       if(stoploss==0){sl=0;}else{sl=Ask-stoploss*Point;} 
       if(takeprofit==0){tp=0;}else{tp=Ask+takeprofit*Point;}
       Ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,4,sl,tp,"SuperFXAntmod",ID,0,Blue);
       } 
     }
    //If bar/candle has moved more than 10 pips in this time frame and if the open is greater than the
   //average of the high and the low and at the current moment the Bid is greater than the open, go short
   if ((High[0]-Low[0])>BarSpread*Point && Bid>(High[0]+Low[0])/2)
     {
     if(orderscnt()<MaxTrades)//This determines how many trades to make at one time
       {
       if(stoploss==0){sl=0;}else{sl=Bid+stoploss*Point;}
       if(takeprofit==0){tp=0;}else{tp=Bid-takeprofit*Point;}
       Ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,4,sl,tp,"SuperFXAntmod",ID,0,Red); 
       }
     }  
   return(0);
  }

//Figure out how many lots to use
int subLotSize()
   {
   int lotMM = MathCeil(AccountFreeMargin() *  Risk / 1000) / 100;
	   if(lotMM < 0.1)                  lotMM = Lots;
	   if((lotMM > 0.5) && (lotMM < 1)) lotMM = Lots;
	   if(lotMM > 1)                    lotMM = MathCeil(lotMM);
	   if(lotMM > 100)                  lotMM = 100;
	return (lotMM);
   }

